/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: engineglobals.h,v 1.4 2004/01/20 02:48:43 syn9 Exp $
*/

#ifndef INCLUDED_ENGINEGLOBALS_HEADER
#define INCLUDED_ENGINEGLOBALS_HEADER

// The size of this file is exponentionaly propotional to the need of
// refactoring


#define pi              3.141592
#define rad             pi / 180

#define viewdist		22999
#define yes				1
#define no				0
#define up              0
#define down            1
#define left            2
#define right           3

#define max_planes	500
#define max_polies	1000
#define max_points	1000
#define max_lights	200

#include <allegro.h>
#include <vector>

struct point_t
{
	float nsx, nsy, nsz;
	float sz;
	float psx, psy, psz;
	float x, y;
	float xx, yy, zz, ybase;
	float scale;//guessing
	bool flag;
	bool active;
	int	plane, point, water;
};

struct poly_t
{
	int p1, p2, p3;
 	int tx;
	short u[3], v[3];
	float nx, ny, nz;
	int plane, poly, clipped, trigger;
	bool clipmonster, clipkey, clipmonsterdoor, clipkeydoor;
};

extern std::vector<point_t> pointinfo;
extern std::vector<poly_t> polyinfo;

struct plane_t
{
	bool	active, condensed;
	float	basex, basey, basez, xrot, yrot, zrot, endx, endy, endz, height, rbx, rby, rbz;
	short	rows, cols, lastpoint, lastpoly, npoints, npolies;
	float	pointinfo[max_points][12];
			//base x, y, z, rotated x, y, z, global point index, active, copy point, light > 0 = light # - 1, light on/off, shown
	short	polyinfo[max_polies][11];
			//p1, p2, p3, tx, [not used], global poly index, active, clipped, trigger, alpha, shown
	short	polyvtx[max_polies][6];
			//u123,v123
	BITMAP *radiosity[max_polies];
	short	radiosity_setup[max_polies];
	bool	radiosity_index[max_polies][16][16];

};

struct light_t
{	
	float	strength;
	short	lightr, lightg, lightb;	
};

#define maxmonster	20
struct monster_t
{	
	short	health, attack;
	float	speed;	
};

struct monsteri_t
{	
	short	id, health, headingx, headingz, scx, scy, curstatus, walkdir, attack, maxhealth, hue;
	float	x, y, z, ratio, curframe;
};

struct object_t
{
	bool	active;
	float	x, y, z, targetx, targety, targetz, ratio;
	short	icon, scx, scy, item;
};

struct item_t
{	
	bool	active;
	float	x, y, z;
	int	icon, room;
};

extern item_t items[100];
extern short nitems;

extern object_t object[100];
extern monster_t monsterdata[11];
extern monsteri_t monsterinfo[1000][maxmonster];
extern short nenemies[1000], nspawn;
extern float spawnloc[maxmonster][3];

extern bool room_clear[1000], entered;

extern plane_t planeinfo[max_planes];
extern light_t lightinfo[max_lights];

extern short lights[max_lights][2];
extern int	vdist, zm;

extern char textureset[100], mapfile[100];

extern float camx, camy, camz, gamma;
extern short scrny;
extern int lightres, health, maxenemies, numenemies;

extern float tx1, tx2, tx3;
extern float ty1, ty2, ty3;
extern float tz1, tz2, tz3;
extern float stp;

extern float rx0, rx1, rx2, rx3;
extern float ry0, ry1, ry2, ry3;
extern float rz0, rz1, rz2, rz3;

extern float prexx, preyx, prezx;
extern float prexy, preyy, prezy;
extern float prexz, preyz, prezz;

extern float camrx, camry, camrz;

extern float basescrny;

extern short bvsync;

extern short start, depth;

extern short dbuffer[viewdist+1];

extern bool  bfc, sound;
extern short trigger[100], curmap;
extern short FPS, fpr, mapx, mapz, vispolys, npolies, npoints, refreshrate, nplanes, endplane, lastlight;
extern double globaltime, timer, freeze, gtime, ti;

extern short nvtx;
extern short vtx[256][6];
extern float fpsr, ripplex, ripplez, rippleamp, ripplefalloff, ripplewash;

extern float current_fade_level; // 0.0 = black; 1.0 = normal;
extern float target_fade_level; // the fade level we want to fade to
extern float fade_speed;        // change per frame (should become per second)

extern float fightfocus[3], focusofs[3], mdistance[100];

extern BITMAP *textures[300];
extern BITMAP *sprites[128];
extern BITMAP *offscreen, *temp, *temp2;

extern PALETTE pal;
extern COLOR_MAP trans_table;

extern int   xres, xcenter, yres, ycenter, wideheight, playerhue;
extern float xzoomratio, yzoomratio;

extern bool generating_radiosity;

#endif
