/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: fileinput.cpp,v 1.4 2004/01/20 03:05:27 syn9 Exp $
*/

#include "fileinput.h"
#include "engineglobals.h"
#include "render.h"


void load_file_v1(char* rfile)
{
	FILE *fp;	
	int	c = 0, d, e, whitec = makecol(192, 192, 192);
	char tmp[100];

	
	curmap = (short)strtod(rfile, NULL);
	BITMAP *temppcx;

	sprintf(mapfile, "data/maps/%s.dtl", rfile);
			
    fp = fopen(mapfile, "r");
    	
	fscanf(fp, "%d", &c);

	fscanf(fp, "%s", &tmp);
	fscanf(fp, "%d", &endplane);
	fscanf(fp, "%d", &lastlight);
		
	fscanf(fp, "%s", &tmp);

	int lx, ly, rx, ry, w, h;

	h = 16;
	w = 256;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;
	rx = lx + w - 1;
	ry = ly + h - 1;

	int bluec = makecol(80, 0, 0);

	for (c = 0; c < max_planes; c++)
	{
		planeinfo[c].active = FALSE;
	}

	for (c = 0; c <= endplane; c++)
	{		
		sprintf(tmp, "Loading...");
		textout(screen, font, tmp, lx + 2, ly + 2, whitec);
		rect (screen, lx, ly + 16, lx + w , ly + h + 16, whitec);
		rectfill (screen, lx + 2, ly + 16 + 2, lx + (w - 4) * (float)c / endplane, ly + h + 16 - 2, bluec);
		
		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].active = TRUE;
		if (d == 0) planeinfo[c].active = FALSE;

		fscanf(fp, "%d", &d);
		if (d == 1) planeinfo[c].condensed = TRUE;
		if (d == 0) planeinfo[c].condensed = FALSE;

		fscanf(fp, "%f", &planeinfo[c].basex);
		fscanf(fp, "%f", &planeinfo[c].basey);
		fscanf(fp, "%f", &planeinfo[c].basez);

		fscanf(fp, "%f", &planeinfo[c].xrot);
		fscanf(fp, "%f", &planeinfo[c].yrot);
		fscanf(fp, "%f", &planeinfo[c].zrot);

		fscanf(fp, "%f", &planeinfo[c].endx);
		fscanf(fp, "%f", &planeinfo[c].endy);
		fscanf(fp, "%f", &planeinfo[c].endz);

		fscanf(fp, "%f", &planeinfo[c].height);

		fscanf(fp, "%f", &planeinfo[c].rbx);
		fscanf(fp, "%f", &planeinfo[c].rby);
		fscanf(fp, "%f", &planeinfo[c].rbz);

		fscanf(fp, "%d", &planeinfo[c].rows);
		fscanf(fp, "%d", &planeinfo[c].cols);
		fscanf(fp, "%d", &planeinfo[c].lastpoint);
		fscanf(fp, "%d", &planeinfo[c].lastpoly);
		fscanf(fp, "%d", &planeinfo[c].npoints);
		fscanf(fp, "%d", &planeinfo[c].npolies);

		if (planeinfo[c].active)
		{

			for (d = 0; d <= planeinfo[c].lastpoint; d++)
			{
				for (e = 0; e < 11; e++)
				{
					fscanf(fp, "%f", &planeinfo[c].pointinfo[d][e]);
				}
			}

			sprintf(tmp, "data/maps/shadowmap/i%s_%d.bmp", rfile, c);
			temppcx = load_bmp(tmp, pal);

			for (d = 0; d <= planeinfo[c].lastpoly; d++)
			{
				for (e = 0; e < 10; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyinfo[d][e]);
				}
				for (e = 0; e < 6; e++)
				{
					fscanf(fp, "%d", &planeinfo[c].polyvtx[d][e]);
				}

				fscanf(fp, "%d", &e);
				if (e == 1)
				{				
					//sprintf(tmp, "data/maps/shadowmap2/i%s_%d_%d.bmp", rfile, c, d);
					//temppcx = load_bmp(tmp, pal);
					
					if (planeinfo[c].radiosity_setup[d] == 0) planeinfo[c].radiosity[d] = create_system_bitmap(16, 16);
					blit (temppcx, planeinfo[c].radiosity[d], d * 16, 0, 0, 0, 16, 16);

					planeinfo[c].radiosity_setup[d] = 2;
				}
			}
			destroy_bitmap(temppcx);

		}

		for (d = 0; d < lastlight; d++)
		{
			fscanf(fp, "%f", &lightinfo[d].strength);
			fscanf(fp, "%d", &lightinfo[d].lightr);
			fscanf(fp, "%d", &lightinfo[d].lightg);
			fscanf(fp, "%d", &lightinfo[d].lightb);
		}

	}

	fclose(fp);

	d = 0;

	for (c = 0; c < nitems; c++)
	{
		if (items[c].room == curmap && curmap && items[c].active)
		{
			object[d].x = items[c].x;
			object[d].y = items[c].y;
			object[d].z = items[c].z;
			object[d].active = TRUE;
			object[d].icon = items[c].icon;
			object[d].targetx = object[d].x;
			object[d].targety = object[d].y + 1.5;
			object[d].targetz = object[d].z;
			object[d].item = c;
			d++;
		}
	}
	
}



void load_itemdat()
{
	FILE *fp;	
	int	c = 0, a, whitec = makecol(192, 192, 192);
	char tmp[100];

	sprintf(tmp, "data/items.dat");
			
    fp = fopen(tmp, "r");
    	
	fscanf(fp, "%d", &c);

	fscanf(fp, "%d", &nitems);

	for (c = 0; c < nitems; c++)
	{
		fscanf(fp, "%d", &items[c].room);
		fscanf(fp, "%f", &items[c].x);		
		fscanf(fp, "%f", &items[c].y);		
		fscanf(fp, "%f", &items[c].z);		
		fscanf(fp, "%d", &items[c].icon);
		items[c].active = TRUE;
	}
	

	fclose(fp);

}

void save_itemdat()
{

	FILE *fp;
	char tmp[100];

	sprintf(tmp, "data/items.dat");
		
	fp = fopen(tmp, "w");
		
	int version = 1;

	fprintf(fp, "%d\n", version);

	int c, a;

	fprintf(fp, "%d\n", nitems);

	for (c = 0; c < nitems; c++)
	{
		fprintf(fp, "%d\n", items[c].room);
		fprintf(fp, "%f\n", items[c].x);		
		fprintf(fp, "%f\n", items[c].y);		
		fprintf(fp, "%f\n", items[c].z);		
		fprintf(fp, "%d\n", items[c].icon);		
	}

	fclose(fp);
}


void load_monsterdat()
{
	FILE *fp;	
	int	c = 0, a, whitec = makecol(192, 192, 192);
	char tmp[100];

	sprintf(tmp, "data/monsters.dat");
			
    fp = fopen(tmp, "r");
    	
	fscanf(fp, "%d", &c);

	for (c = 0; c < 1000; c++)
	{
		fscanf(fp, "%d", &nenemies[c]);
		for (a = 0; a < nenemies[c]; a++)
		{
			fscanf(fp, "%d", &monsterinfo[c][a].id);
			monsterinfo[c][a].health = monsterdata[monsterinfo[c][a].id].health;
			monsterinfo[c][a].maxhealth = monsterdata[monsterinfo[c][a].id].health;
			monsterinfo[c][a].attack = monsterdata[monsterinfo[c][a].id].attack;
			maxenemies++;
		}
	}

	fclose(fp);

}


void save_monsterdat()
{

	FILE *fp;
	char tmp[100];

	sprintf(tmp, "data/monsters.dat");
		
	fp = fopen(tmp, "w");
		
	int version = 1;

	fprintf(fp, "%d\n", version);

	int c, a;

	for (c = 0; c < 1000; c++)
	{
		fprintf(fp, "%d\n", nenemies[c]);
		for (a = 0; a < nenemies[c]; a++)
		{
			fprintf(fp, "%d\n", monsterinfo[c][a].id);
		}
	}

	fclose(fp);
}


