/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: game.cpp,v 1.3 2004/01/20 02:48:43 syn9 Exp $
*/

#include "../engine/fileinput.h"
#include "../engine/engineglobals.h"
#include "../engine/render.h"

#include "gamefileinput.h"
#include "gameglobals.h"
#include "game.h"

#include <math.h>
#include <ctime>

void calcsprites()
{
    short ind, sox, scx, scy, c;
    float nx, ny, nz, sx, sy, sz, ratio;

    nx = 1 + playerx - focusofs[0];
    ny = playery - focusofs[1];
    nz = playerz - focusofs[2];

    sx = nx * prexx + ny * preyx + nz * prezx - camx;
    sz = nx * prexz + ny * preyz + nz * prezz - camz;

    sox = short(xcenter + sx / sz * xzoomratio);
   
    nx = playerx - focusofs[0];
    ny = playery - focusofs[1];
    nz = playerz - focusofs[2];

    sx = nx * prexx + ny * preyx + nz * prezx - camx;
    sy = nx * prexy + ny * preyy + nz * prezy - camy;
    sz = nx * prexz + ny * preyz + nz * prezz - camz;

    scx = short(xcenter + sx / sz * xzoomratio);
    scy = short(ycenter + sy / sz * yzoomratio - scrny);

    ratio = (float)abs(scx - sox) / 22;

    scx = scx - int(24 * ratio);
    scy = scy - int(46 * ratio);

    ind = -int(sz * 75) - 400;

    for(;;)
    {
        if (ind > vdist || ind < 0)
            break;

        if (dbuffer[ind] > 0)
            ind = ind + 1;
        if (dbuffer[ind] == 0)
        {
            dbuffer[ind] = 1;
            if (ind < start)
                start = ind;
            if (ind > depth)
                depth = ind;
            break;
        }
    }

    pscx = scx;
    pscy = scy;
    pratio = ratio;
 
	for (c = 0; c < nenemies[curmap]; c++)
	{
		if (monsterinfo[curmap][c].health > 0) 
		{

			nx = 1 + monsterinfo[curmap][c].x - focusofs[0];
			ny = monsterinfo[curmap][c].y - focusofs[1];
			nz = monsterinfo[curmap][c].z - focusofs[2];

			sx = nx * prexx + ny * preyx + nz * prezx - camx;
			sz = nx * prexz + ny * preyz + nz * prezz - camz;

			sox = short(xcenter + sx / sz * xzoomratio);
   
			nx = monsterinfo[curmap][c].x - focusofs[0];
			ny = monsterinfo[curmap][c].y - focusofs[1];
			nz = monsterinfo[curmap][c].z - focusofs[2];

			sx = nx * prexx + ny * preyx + nz * prezx - camx;
			sy = nx * prexy + ny * preyy + nz * prezy - camy;
			sz = nx * prexz + ny * preyz + nz * prezz - camz;

			scx = short(xcenter + sx / sz * xzoomratio);
			scy = short(ycenter + sy / sz * yzoomratio - scrny);

			ratio = (float)abs(scx - sox) / 22;

			scx = scx - int(24 * ratio);
			scy = scy - int(46 * ratio);

			ind = -int(sz * 75) - 400;

			for(;;)
			{
				if (ind > vdist || ind < 0)
					break;

				if (dbuffer[ind] > 0)
					ind = ind + 1;
				if (dbuffer[ind] == 0)
				{
					dbuffer[ind] = 2 + c;
					if (ind < start)
						start = ind;
					if (ind > depth)
						depth = ind;
					break;
				}
			}

			monsterinfo[curmap][c].scx = scx;
			monsterinfo[curmap][c].scy = scy;
		    monsterinfo[curmap][c].ratio = ratio;
		}
	}

	for (c = 0; c < 50; c++)
	{

		if (object[c].active)
		{
			
			nx = 1 + object[c].x - focusofs[0];
			ny = object[c].y - focusofs[1];
			nz = object[c].z - focusofs[2];

			sx = nx * prexx + ny * preyx + nz * prezx - camx;
			sz = nx * prexz + ny * preyz + nz * prezz - camz;

			sox = short(xcenter + sx / sz * xzoomratio);
   
			nx = object[c].x - focusofs[0];
			ny = object[c].y - focusofs[1];
			nz = object[c].z - focusofs[2];
	
			sx = nx * prexx + ny * preyx + nz * prezx - camx;
			sy = nx * prexy + ny * preyy + nz * prezy - camy;
			sz = nx * prexz + ny * preyz + nz * prezz - camz;

			scx = short(xcenter + sx / sz * xzoomratio);
		    scy = short(ycenter + sy / sz * yzoomratio - scrny);

			ratio = (float)abs(scx - sox) / 22;

			scx = scx - int(8 * ratio);
			scy = scy - int(8 * ratio);

			ind = -int(sz * 75) - 400;

			for(;;)
			{
				if (ind > vdist || ind < 0)
					break;

				if (dbuffer[ind] > 0)
					ind = ind + 1;
				if (dbuffer[ind] == 0)
				{
					dbuffer[ind] = 50 + c;
					if (ind < start)
						start = ind;
					if (ind > depth)
						depth = ind;
					break;
				}
			}

			object[c].scx = scx;
			object[c].scy = scy;
			object[c].ratio = ratio;
		}
	}
}

void checkkbd()
{
    float ofs;

	ofs = .16 * fpsr;

	float ox = 0, oz = 0, p, clearance = 1;

	bool passx = TRUE, passy = TRUE, pass = TRUE;
	
		
	short	x, y;
	int whitec = makecol(255, 255, 255);

	
		
	fill_surround(TRUE, playerx, playery, playerz);
	

	
	if (key[KEY_UP]) oz = -1;
    if (key[KEY_DOWN]) oz = 1;
	
	if (oz != 0)
	{
		for (y = -ofs * clearance; y < ofs * clearance; y++)
		{
			p = getpixel(surroundbmp, 64 + ox * ofs * 8, 64 + oz * ofs * 8 + y);
			if (p == whitec) passy = FALSE;
		}
		if (!passy) oz = 0;
	}	

	if (key[KEY_LEFT]) ox = -1;
    if (key[KEY_RIGHT]) ox = 1;
	if (ox != 0)
	{
		for (x = -ofs * clearance; x <= ofs * clearance; x++)
		{
			p = getpixel(surroundbmp, 64 + ox * ofs * 8 + x, 64 + oz * ofs * 8);
			if (p == whitec) passx = FALSE;	
		}
		if (!passx) ox = 0;
	}

	if (ox != 0 && oz != 0)
	{
		for (x = -ofs * clearance; x <= ofs * clearance; x++)
		{
			for (y = -ofs * clearance; y < ofs * clearance; y++)
			{
				p = getpixel(surroundbmp, 64 + ox * ofs * 8 + x, 64 + oz * ofs * 8 + y);
				if (p == whitec) pass = FALSE;
			}	
		}
		if (!pass)
		{
			ox = 0;
			oz = 0;
		}
	}

	p = getpixel(surroundbmp, 64 + ox * ofs * 8, 64 + oz * ofs * 8);
	if (p < whitec)
	{
		p = float(p) / 256 - 2;
		if (p > -1.5 && p < 1.5)
		{
			playery += p;
			playerx += ox * ofs;
			playerz += oz * ofs;
			
		}
	
	}

	if (ox != 0 || oz != 0)
	{
		curframe += 2 * ofs;
		while (curframe > 6) { curframe -= 6; }

		if (oz < 0) walkdir = up;
		if (oz > 0) walkdir = down;
		if (ox < 0) walkdir = left;
		if (ox > 0) walkdir = right;

		curstatus = status_walking;		
	} else {
		if (curstatus != status_attacking)
		{
			curstatus = status_standing;
		
			curframe += 1.5 * ofs;
			while (curframe > 6) { curframe -= 6; }		
		}
	}
	

	fightfocus[0] = playerx;
	fightfocus[1] = playery;
	fightfocus[2] = playerz;

	if (playerhue > 0) playerhue /= 2;

	
	int newob = 0, c;
	if (key[KEY_SPACE] && freeze < timer)
	{		
		for (c = 0; c < 50; c++)
		{
			if (!object[c].active)
			{
				newob = c;
				break;
			}
		}
			
		curframe = 0;
		curstatus = status_attacking;
		freeze = timer + .002 * fpsr;

		object[newob].active = TRUE;
		object[newob].x = playerx;
		object[newob].y = playery + 1.5;
		object[newob].z = playerz;
		object[newob].icon = 10 + walkdir;
		object[newob].targetx = object[newob].x;
		object[newob].targety = object[newob].y;
		object[newob].targetz = object[newob].z;
		if (walkdir == up) object[newob].targetz = object[newob].z - 10;
		if (walkdir == down) object[newob].targetz = object[newob].z + 10;
		if (walkdir == left) object[newob].targetx = object[newob].x - 10;
		if (walkdir == right) object[newob].targetx = object[newob].x + 10;
			
	}

	if (curstatus == status_attacking)
	{
		curframe += 4 * ofs;
		if (curframe > 6)
		{
			curstatus = status_standing;
			curframe = 0;
		}
	}

}

void cleanup_scene()
{
	int a, c;	
	
	for (a = 0; a <= endplane; a++)
	{
		for (c = 0; c <= planeinfo[a].lastpoly; c++)
		{
			if (planeinfo[a].polyinfo[c][10] == 0) planeinfo[a].polyinfo[c][6] = 2;
		}
		for (c = 0; c <= planeinfo[a].lastpoint; c++)
		{
			if (planeinfo[a].pointinfo[c][11] == 0) planeinfo[a].pointinfo[c][7] = 1;
		}
	}
}

void drawdie()
{
	int lx, ly, w, h, whitec = makecol(192, 192, 192);

	char tmp[100];
	w = 320;
	h = 72;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;

	updscreen(TRUE);	

	win (0, lx, ly, lx + w, ly + h);
	sprintf(tmp, "Marik, The Great Demon Slayer");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 4, whitec);
	sprintf(tmp, "Has Fallen");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 16, whitec);

	sprintf(tmp, "Hit ESC to quit");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 60, whitec);

	updscreen(TRUE);	

	while (!key[KEY_ESC]) { poll_keyboard(); }

}

void drawwin()
{
	int lx, ly, w, h, whitec = makecol(192, 192, 192);

	char tmp[100];
	w = 320;
	h = 72;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;

	updscreen(TRUE);	

	win (0, lx, ly, lx + w, ly + h);
	sprintf(tmp, "Marik, The Great Demon Slayer");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 4, whitec);
	sprintf(tmp, "Has Rid these lands of the");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 16, whitec);
	sprintf(tmp, "demon hords!");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 16, whitec);

	sprintf(tmp, "Hit ESC to quit");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 60, whitec);

	updscreen(TRUE);	
	health = 0;

	while (!key[KEY_ESC]) { poll_keyboard(); }

}

void drawhud()
{

	int whitec = makecol(192,192,192), i, d;
	char tmp[100];	

	rectfill (offscreen, 0, 0, xres - 1, wideheight, 0);
	rectfill (offscreen, 0, yres - wideheight, xres - 1, yres - 1, 0);

	sprintf(tmp, "Marik The Demon Slayer");
	textout(offscreen, font, tmp, 40, 4, whitec);

	sprintf(tmp, "Enemis Killed %d/%d", numenemies, maxenemies);
	textout(offscreen, font, tmp, 40, 36, whitec);

	
	set_hue_blender(255, 0, 0, playerhue);

	draw_trans_sprite(offscreen, objects[0], 4, 4);	

	int orangec = makecol(255, 196, 64), farx;

	farx = xres - 9 * 32;
	d = float(farx - 40) / health;

	drawing_mode(DRAW_MODE_TRANS, NULL, NULL, NULL);
	for (i = 0; i < health; i++)
	{
		rectfill(offscreen, 40 + i * d, 16, 40 + (i + 1) * d - 2, 32, orangec);
	}
	
	drawing_mode(DRAW_MODE_SOLID, NULL, NULL, NULL);
	
	for (i = 1; i < 10; i++)
	{
		if (inventory[i] > 0) draw_trans_sprite(offscreen, objects[i], xres - 10 * 32 + i * 32, 4);
	}
	
	return;
}


void drawpolys()
{    
	int i, poly, p1, p2, p3, t, a, bluec = makecol(0,0,192), redc = makecol(192,0,0);
	int greyc = makecol(96, 96, 96), whitec = makecol(192,192,192), greenc = makecol(0,192,0), yellowc = makecol(224, 224, 32);
	short u[3], v[3], level;
	int trans = makecol(255, 0, 255), ambientr, ambientg, ambientb;

	float visibility, xcyc = 0, ycyc;
    
    V3D_f v1, v2, v3;

    vispolys = 0;

	ambientr = getr(ambientc);
	ambientg = getg(ambientc);
	ambientb = getb(ambientc);

		
	for (i = depth; i >= start; i--)
    {
        if (dbuffer[i] == 0)
            continue;

        if (dbuffer[i] > 99)
        {
            poly = short(dbuffer[i] - 100);
    
            xcyc = 0;
			ycyc = 0;
			if (polyinfo[poly].trigger == 1)
			{
				xcyc = cycle;
				ycyc = cycle;
			}
			if (polyinfo[poly].trigger == 2) ycyc = -cycle * 7;
			
			p1 = polyinfo[poly].p1;
            p2 = polyinfo[poly].p2;
            p3 = polyinfo[poly].p3;
            t = polyinfo[poly].tx;
			for (a = 0; a < 3; a++)
			{
				u[a] = polyinfo[poly].u[a];
				v[a] = polyinfo[poly].v[a];
			}

            v1.x = pointinfo[p1].x;
            v1.y = pointinfo[p1].y;
			v1.z = pointinfo[p1].sz;
            v1.u = u[0] + xcyc;
            v1.v = v[0] + ycyc;
			v1.c = ambientc;

            v2.x = pointinfo[p2].x;
            v2.y = pointinfo[p2].y;
			v2.z = pointinfo[p2].sz;
            v2.u = u[1] + xcyc;
            v2.v = v[1] + ycyc;

            v3.x = pointinfo[p3].x;
            v3.y = pointinfo[p3].y;
			v3.z = pointinfo[p3].sz;
            v3.u = u[2] + xcyc;
            v3.v = v[2] + ycyc;
			visibility = ((pointinfo[p1].scale + pointinfo[p2].scale + pointinfo[p3].scale) / 3 - camz * zm) / vdist;
			visibility = 1 - sin(1.75 * visibility);

			if (visibility < 0) visibility = 0;
			if (visibility > 1) visibility = 1;
			
			level = planeinfo[polyinfo[poly].plane].polyinfo[polyinfo[poly].poly][8];
			if (level > 0)
			{
				set_trans_blender(255,255,255,255 * (float(100 - level) / 100));
				triangle3d_f(offscreen, POLYTYPE_PTEX_MASK_TRANS, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);
			} else {
				if (polyinfo[poly].clipkeydoor || polyinfo[poly].clipmonsterdoor)
				{
					if (polyinfo[poly].clipkeydoor)
					{
						if (!(entered && inventory[curdungeon] == 0))
						{
							set_trans_blender(255,255,255,128);
							triangle3d_f(offscreen, POLYTYPE_PTEX_MASK_TRANS, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
						} else {
							triangle3d_f(offscreen, POLYTYPE_PTEX_MASK, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
						}
					}
					if (polyinfo[poly].clipmonsterdoor)
					{
						if (!(entered && !room_clear[curmap]))
						{
							set_trans_blender(255,255,255,128);
							triangle3d_f(offscreen, POLYTYPE_PTEX_MASK_TRANS, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
						} else {
							triangle3d_f(offscreen, POLYTYPE_PTEX_MASK, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
						}
					}
				} else {
					triangle3d_f(offscreen, POLYTYPE_PTEX_MASK, planeinfo[polyinfo[poly].plane].radiosity[polyinfo[poly].poly], &v1, &v2, &v3);	
				}				
			}

			planeinfo[polyinfo[poly].plane].polyinfo[polyinfo[poly].poly][10] = 1;
			planeinfo[pointinfo[p1].plane].pointinfo[pointinfo[p1].point][11] = 1;
			planeinfo[pointinfo[p2].plane].pointinfo[pointinfo[p2].point][11] = 1;
			planeinfo[pointinfo[p3].plane].pointinfo[pointinfo[p3].point][11] = 1;
			
				
			++vispolys;
        }

        if (dbuffer[i] > 1 && dbuffer[i] < 50) drawsprite(dbuffer[i]-2);
		if (dbuffer[i] > 49 && dbuffer[i] < 100) drawsprite(dbuffer[i]);
		if (dbuffer[i] == 1) drawsprite(-1);
        
        dbuffer[i] = 0;
    }


}



void drawsprite(short spritenum)
{
	int o, r, i, p, orangec = makecol(255, 196, 64);
	
	if (spritenum == -1) 
	{		
		stretch_sprite(offscreen, frames[0][curstatus][walkdir][(short)curframe], pscx, pscy, int(48 * pratio), int(48 * pratio));				
	} 
	if (spritenum < 50)
	{		
		o = monsterinfo[curmap][spritenum].id;
		r = 48;
		if (o > 4) r = 72;
		stretch_sprite(offscreen, frames[monsterinfo[curmap][spritenum].id][monsterinfo[curmap][spritenum].curstatus][monsterinfo[curmap][spritenum].walkdir][(short)monsterinfo[curmap][spritenum].curframe], monsterinfo[curmap][spritenum].scx, monsterinfo[curmap][spritenum].scy - int((r - 48) * monsterinfo[curmap][spritenum].ratio), int(r * monsterinfo[curmap][spritenum].ratio), int(r * monsterinfo[curmap][spritenum].ratio));		
		set_hue_blender(255, 0, 0, monsterinfo[curmap][spritenum].hue);
		drawing_mode(DRAW_MODE_TRANS, NULL, NULL, NULL);
		for (i = 0; i < monsterinfo[curmap][spritenum].health; i++)
		{
			rectfill (offscreen, monsterinfo[curmap][spritenum].scx + i * 8, monsterinfo[curmap][spritenum].scy, monsterinfo[curmap][spritenum].scx + i * 8 + 6, monsterinfo[curmap][spritenum].scy + 8, orangec);
		}
		drawing_mode(DRAW_MODE_SOLID, NULL, NULL, NULL);
	} else {		
		o = spritenum - 50;
		stretch_sprite(offscreen, objects[object[o].icon], object[o].scx, object[o].scy, int(16 * object[o].ratio), int(16 * object[o].ratio));
	}

}

void fill_surround(bool playercheck, float cx, float cy, float cz)
{
	short	c, i, p1, p2, p3, minx, minz, maxx, maxz, sx, sz, p, g, whitec = makecol(255, 255, 255);
	float	x, y, z;

	V3D_f v1, v2, v3;

	clear_to_color(surroundbmp, whitec);
	clear(triggerbmp);	

	for (i = depth; i >= start; i--)
    {
        
        if (!(dbuffer[i] > 99)) continue;
        
		c = short(dbuffer[i] - 100);
    		
		p1 = polyinfo[c].p1;
		p2 = polyinfo[c].p2;
		p3 = polyinfo[c].p3;
		
		if (polyinfo[c].clipped) continue;
		if (playercheck && polyinfo[c].clipmonster && entered && !room_clear[curmap]) continue;
		if (playercheck && polyinfo[c].clipkey && entered && inventory[curdungeon] == 0) continue;

		x = float(pointinfo[p1].xx + pointinfo[p2].xx + pointinfo[p3].xx) / 3;			
		z = float(pointinfo[p1].zz + pointinfo[p2].zz + pointinfo[p3].zz) / 3;
		y = pointinfo[p1].yy;
		if (pointinfo[p2].yy > y) y = pointinfo[p2].yy;
		if (pointinfo[p3].yy > y) y = pointinfo[p3].yy;

		x -= cx;
		y -= cy;
		z -= cz;


		if (x > -5 && z > -5 && x < 5 && z < 5 && y > -1.5 && y < 1.5)
		{
			
			v1.x = float(pointinfo[p1].xx - cx + 8) * 8;
            v1.y = float(pointinfo[p1].zz - cz + 8) * 8;
            v1.c = (y + 2) * 256;

            v2.x = float(pointinfo[p2].xx - cx + 8) * 8;
            v2.y = float(pointinfo[p2].zz - cz + 8) * 8;
			
            v3.x = float(pointinfo[p3].xx - cx + 8) * 8;
            v3.y = float(pointinfo[p3].zz - cz + 8) * 8;
			
			
			
			clear(surroundcbmp);

				triangle3d_f(surroundcbmp, POLYTYPE_FLAT, NULL, &v1, &v2, &v3);							
			
				minx = 128;
				minz = 128;
				maxx = -1;
				maxz = -1;

				if (v1.x < minx) minx = v1.x;
				if (v1.x > maxx) maxx = v1.x;
				if (v1.y < minz) minz = v1.y;
				if (v1.y > maxz) maxz = v1.y;

				if (v2.x < minx) minx = v2.x;
				if (v2.x > maxx) maxx = v2.x;
				if (v2.y < minz) minz = v2.y;
				if (v2.y > maxz) maxz = v2.y;

				if (v3.x < minx) minx = v3.x;
				if (v3.x > maxx) maxx = v3.x;
				if (v3.y < minz) minz = v3.y;
				if (v3.y > maxz) maxz = v3.y;

			
				for (sx = minx; sx <= maxx; sx++)
				{				
					for (sz = minz; sz <= maxz; sz++)
					{					
						p = getpixel(surroundcbmp, sx, sz);					
						g = getpixel(surroundbmp, sx, sz);
						if (g == whitec) g = 0;
						if (p > 0 && g < p)
						{
							if (playercheck && sx == 64 && sz == 64 && !polyinfo[c].clipmonster && !polyinfo[c].clipkey) entered = TRUE;
							putpixel(surroundbmp, sx, sz, p);
							putpixel(triggerbmp, sx, sz, polyinfo[c].trigger);
						}					
					}
				}
			//}
		}
	}
}


void gameinit()
{

	BITMAP* temppcx;

	//temppcx = load_pcx("data/textureset/player.pcx", pal);
	//if (!temppcx) { printf("Error loading data/textureset/player.pcx!\n"); exit(1); }	
	
	int c, d;

	char tmp[100];

	ripplex = 0;
	ripplez = 3;
	rippleamp = .2;
	ripplefalloff = 20;
	ripplewash = (float)1 / 8;

	
	for (c = 0; c < 6; c++)
	{
			sprintf(tmp, "data/anim/walkd%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][1][down][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][1][down][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][1][down][c], temppcx, 0, 0, 40, 40);			
		
			sprintf(tmp, "data/anim/walku%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][1][up][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][1][up][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][1][up][c], temppcx, 0, 0, 40, 40);			

			sprintf(tmp, "data/anim/walkl%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][1][left][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][1][left][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][1][left][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/walkr%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][1][right][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][1][right][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][1][right][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standu%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][up][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][up][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][up][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standd%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][down][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][down][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][down][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standl%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][left][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][left][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][left][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/standr%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][0][right][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][0][right][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][0][right][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/atd%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][2][down][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][2][down][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][2][down][c], temppcx, 0, 0, 40, 40);			
		
			sprintf(tmp, "data/anim/atu%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][2][up][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][2][up][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][2][up][c], temppcx, 0, 0, 40, 40);			

			sprintf(tmp, "data/anim/atl%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][2][left][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][2][left][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][2][left][c], temppcx, 0, 0, 40, 40);

			sprintf(tmp, "data/anim/atr%d.bmp", c + 1);
			temppcx = load_bmp(tmp, pal);

			frames[0][2][right][c] = create_system_bitmap(40, 40);
			clear_to_color(frames[0][2][right][c], makecol(255, 0, 255));
			stretch_sprite(frames[0][2][right][c], temppcx, 0, 0, 40, 40);

		
	}

	//temppcx = load_pcx("data/textureset/player.pcx", pal);
	//blit(temppcx, temp2, 0, 96, 0, 0, 31, 31);

	surroundbmp = create_system_bitmap(128, 128);
	surroundcbmp = create_system_bitmap(128, 128);
	triggerbmp = create_system_bitmap(128, 128);

	ambientc = makecol(0, 0, 0);
	cycle = 0;

	wideheight = yres / 5;

	int voices, pass;
	voices = detect_digi_driver(DIGI_AUTODETECT);
	pass = install_sound(DIGI_AUTODETECT, NULL, NULL);

	sound = FALSE;
	if (voices > 0 && pass == 0) 
	{
		sound = TRUE;
		reserve_voices(16, 0);
		//bgmusic[0] = load_sample("data/music/syn9 - bodysnatcher.wav");
		//bgmusic[1] = load_sample("data/music/vamp2.wav");
		//bgmusic[2] = load_sample("data/music/vamp3.wav");
		nowplaying = 0;
		//play_sample(bgmusic[nowplaying], 255, 128, 1000, TRUE);
	}

	for (c = 0; c < 20; c++)
	{
		inventory[c] = 0;
	}

	int i;

	for (i = 1; i < 6; i++)
	{
		monsterdata[i].health = i * 2;
		monsterdata[i].speed = .2 * i;
		monsterdata[i].attack = i * 2;

		monsterdata[i + 5].health = i * 2 + 8;
		monsterdata[i + 5].speed = .2 * i;
		monsterdata[i + 5].attack = i * 4;
		
		monsterdata[i + 10].health = i * 2 + 16;
		monsterdata[i + 10].speed = .2 * i;
		monsterdata[i + 10].attack = i * 6;
	}

	for (i = 1; i < 16; i++)
	{
		for (c = 0; c < 6; c++)
		{
			for (d = 0; d < 4; d++)
			{
				sprintf(tmp, "data/anim/en%d_%d_%d.bmp", i - 1, d, c + 1);
				temppcx = load_bmp(tmp, pal);

				
				frames[i][1][d][c] = create_system_bitmap(40, 40);
				clear_to_color(frames[i][1][d][c], makecol(255, 0, 255));
				stretch_sprite(frames[i][1][d][c], temppcx, 0, 0, 40, 40);

				sprintf(tmp, "data/anim/enf%d_%d_%d.bmp", i - 1, d, c + 1);
				temppcx = load_bmp(tmp, pal);

				frames[i][2][d][c] = create_system_bitmap(40, 40);
				clear_to_color(frames[i][2][d][c], makecol(255, 0, 255));
				stretch_sprite(frames[i][2][d][c], temppcx, 0, 0, 40, 40);

				frames[i][0][d][c] = create_system_bitmap(40, 40);
				clear_to_color(frames[i][2][d][c], makecol(255, 0, 255));
				stretch_sprite(frames[i][2][d][c], temppcx, 0, 0, 40, 40);
			}
		}
	}

	sprintf(tmp, "data/objects/heart.bmp");
	objects[0] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/key1.bmp");
	objects[1] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/key2.bmp");
	objects[2] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/key3.bmp");
	objects[3] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/key4.bmp");
	objects[4] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/key5.bmp");
	objects[5] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/gem1.bmp");
	objects[6] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/gem2.bmp");
	objects[7] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/gem3.bmp");
	objects[8] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/gem4.bmp");
	objects[9] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/arrowu.bmp");
	objects[10] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/arrowd.bmp");
	objects[11] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/arrowl.bmp");
	objects[12] = load_bmp(tmp, pal);

	sprintf(tmp, "data/objects/arrowr.bmp");
	objects[13] = load_bmp(tmp, pal);

	health = 8;

	
	numenemies = 0;
	nitems = 0;


}

void process_trigger()
{
	int p;
	char tmp[100];

	int x, y;
	for (x = -2; x < 3; x++)
	{
		for (y = -2; y < 3; y++)
		{
			p = getpixel(triggerbmp, 64 + x, 64 + y);

			if (p > 999)
			{
				sprintf(tmp, "%d", (short)triggerinfo[p][0]);
				load_file_v1(tmp);
				setup_scene();
				setup_monsters();

				playerx = triggerinfo[p][1];
				playery = triggerinfo[p][2];
				playerz = triggerinfo[p][3];
	
				focusofs[0] = playerx;
				focusofs[1] = playery;
				focusofs[2] = playerz;

				fightfocus[0] = playerx;
				fightfocus[1] = playery;
				fightfocus[2] = playerz;

				break;
			}

			if (p == 8 && inventory[6] > 0 && inventory[7] > 0 && inventory[8] > 0 && inventory[9] > 0)
			{				
				load_file_v1("906");
				setup_scene();
				setup_monsters();

				playerx = triggerinfo[curmap + 2000][1];
				playery = triggerinfo[curmap + 2000][2];
				playerz = triggerinfo[curmap + 2000][3];
					
				focusofs[0] = playerx;
				focusofs[1] = playery;
				focusofs[2] = playerz;

				fightfocus[0] = playerx;
				fightfocus[1] = playery;
				fightfocus[2] = playerz;

				break;

			}
		}
	}
}


void setup_monsters()
{

	int c, loc;
	for (c = 0; c < nenemies[curmap]; c++)
	{
		loc = short((float)rand() / RAND_MAX * nspawn);
		monsterinfo[curmap][c].x = spawnloc[loc][0];
		monsterinfo[curmap][c].y = spawnloc[loc][1];
		monsterinfo[curmap][c].z = spawnloc[loc][2];		

		monsterinfo[curmap][c].headingx = short((float)rand() / RAND_MAX * 3) - 1;
		monsterinfo[curmap][c].headingz = short((float)rand() / RAND_MAX * 3) - 1;
		while (monsterinfo[curmap][c].headingz == monsterinfo[curmap][c].headingx) { monsterinfo[curmap][c].headingz = short((float)rand() / RAND_MAX * 3) - 1; }

	}
}

void setup_scene()
{	
	pointinfo.clear();
	polyinfo.clear();

	float nsx, nsy, nsz;

	int a, c, x, y, nx, ny, nz;

	point_t	tpoint;
	poly_t  tpoly;

	npolies = 0;
	npoints = 0;

	nspawn = 0;

	entered = FALSE;

	curdungeon = curmap / 100;
	
	for (c = 0; c <= endplane; c++)
	{		
		if (planeinfo[c].active)
		{			
			planeinfo[c].npoints = 0;
			planeinfo[c].npolies = 0;

			for (a = 0; a <= planeinfo[c].lastpoint; a++)
			{
				if (planeinfo[c].pointinfo[a][7] == 0)
				{
					nsx = planeinfo[c].pointinfo[a][3] + planeinfo[c].basex;
					nsy = planeinfo[c].pointinfo[a][4] + planeinfo[c].basey;
					nsz = planeinfo[c].pointinfo[a][5] + planeinfo[c].basez;					

					nx = nsx;
					ny = nsy;
					nz = nsz;

					
					tpoint.nsx = nsx * prexx + nsy * preyx + nsz * prezx;
					tpoint.nsy = nsx * prexy + nsy * preyy + nsz * prezy;
					tpoint.nsz = nsx * prexz + nsy * preyz + nsz * prezz;
					tpoint.plane = c;
					tpoint.point = a;
					tpoint.xx = nsx;
					tpoint.yy = nsy;
					tpoint.ybase = nsy;
					tpoint.zz = nsz;
					tpoint.water = 0;

					planeinfo[c].pointinfo[a][6] = pointinfo.size();
					pointinfo.push_back(tpoint);					

					pointinfo[planeinfo[c].pointinfo[a][6]].active = FALSE;
					planeinfo[c].pointinfo[a][11] = 0;
									
					planeinfo[c].npoints++;	
					
					npoints++;

				}
			}

			for (a = 0; a <= planeinfo[c].lastpoly; a++)
			{				
				if (planeinfo[c].polyinfo[a][6] < 2)
				{
					tpoly.p1 = planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][0]][6];
					tpoly.p2 = planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][1]][6];
					tpoly.p3 = planeinfo[c].pointinfo[planeinfo[c].polyinfo[a][2]][6];
					tpoly.tx = planeinfo[c].polyinfo[a][3];
					tpoly.u[0] = planeinfo[c].polyvtx[a][0];
					tpoly.v[0] = planeinfo[c].polyvtx[a][1];
					tpoly.u[1] = planeinfo[c].polyvtx[a][2];
					tpoly.v[1] = planeinfo[c].polyvtx[a][3];
					tpoly.u[2] = planeinfo[c].polyvtx[a][4];
					tpoly.v[2] = planeinfo[c].polyvtx[a][5];
					if (planeinfo[c].polyinfo[a][9] == 1)
					{
						pointinfo[tpoly.p1].water = 1;
						pointinfo[tpoly.p2].water = 1;
						pointinfo[tpoly.p3].water = 1;
					}
					if (planeinfo[c].polyinfo[a][9] == 2)
					{
						pointinfo[tpoly.p1].water = 2;
						pointinfo[tpoly.p2].water = 2;
						pointinfo[tpoly.p3].water = 2;
					}
					
					tpoly.clipmonster = FALSE;
					tpoly.clipmonsterdoor = FALSE;
					tpoly.clipkey = FALSE;
					tpoly.clipkeydoor = FALSE;
					if (planeinfo[c].polyinfo[a][9] == 3) tpoly.clipmonster = TRUE;
					if (planeinfo[c].polyinfo[a][9] == 4) tpoly.clipmonsterdoor = TRUE;
					if (planeinfo[c].polyinfo[a][9] == 5) tpoly.clipkey = TRUE;
					if (planeinfo[c].polyinfo[a][9] == 6) tpoly.clipkeydoor = TRUE;
					
					if (planeinfo[c].polyinfo[a][9] == 7 && nspawn < maxmonster)
					{
						spawnloc[nspawn][0] = float(pointinfo[tpoly.p1].xx + pointinfo[tpoly.p2].xx + pointinfo[tpoly.p3].xx) / 3;
						spawnloc[nspawn][1] = float(pointinfo[tpoly.p1].yy + pointinfo[tpoly.p2].yy + pointinfo[tpoly.p3].yy) / 3;
						spawnloc[nspawn][2] = float(pointinfo[tpoly.p1].zz + pointinfo[tpoly.p2].zz + pointinfo[tpoly.p3].zz) / 3;
						nspawn++;
					}

					pointinfo[tpoly.p1].active = TRUE;
					pointinfo[tpoly.p2].active = TRUE;
					pointinfo[tpoly.p3].active = TRUE;
										
					tpoly.plane = c;
					tpoly.poly = a;
					tpoly.clipped = FALSE;
					if (planeinfo[c].polyinfo[a][7] == 1) tpoly.clipped = TRUE;
					tpoly.trigger = planeinfo[c].polyinfo[a][9];
					planeinfo[c].polyinfo[a][10] = 0;

									
					planeinfo[c].polyinfo[a][5] = polyinfo.size();
					if (planeinfo[c].radiosity_setup[a] == 0)
					{
						planeinfo[c].radiosity_setup[a] = 1;
						planeinfo[c].radiosity[a] = create_system_bitmap(16,16);						
					}
					if (planeinfo[c].radiosity_setup[a] == 1)
					{
						planeinfo[c].radiosity_setup[a] = 2;
						for (x = 0; x < 16; x++)
						{
							for (y = 0; y < 16; y++)
							{
								putpixel(planeinfo[c].radiosity[a], x, y, 0);
							}
						}						
						blit(textures[tpoly.tx], planeinfo[c].radiosity[a], 0, 0, 0, 0, 16, 16);
					}

					planeinfo[c].polyinfo[a][5] = polyinfo.size();
					polyinfo.push_back(tpoly);
					planeinfo[c].npolies++;
					npolies++;
				}
			}
			
		}
	}

}

void updobjects()
{

	int c, a;

	float targetx, targety, targetz, clearance = 1.2;
	for (c = 0; c < 50; c++)
	{
		if (object[c].active)
		{
			object[c].x = object[c].x + (object[c].targetx - object[c].x) * .03 * fpsr;
			object[c].y = object[c].y + (object[c].targety - object[c].y) * .03 * fpsr;
			object[c].z = object[c].z + (object[c].targetz - object[c].z) * .03 * fpsr;

			if (object[c].icon < 10)
			{
				if (sqrt((playerx - object[c].x) * (playerx - object[c].x) + (playery - object[c].y + 1.5) * (playery - object[c].y + 1.5) + (playerz - object[c].z) * (playerz - object[c].z)) < 1)
				{
					object[c].active = FALSE;
					items[object[c].item].active = FALSE;
					
					inventory[object[c].icon] = 1;
					if (object[c].icon == 0) health *= 1.5;
				}
			}

			if (object[c].icon > 9)
			{
				if (object[c].x > object[c].targetx - .1 && object[c].x < object[c].targetx + .1 && object[c].y > object[c].targety - .1 && object[c].y < object[c].targety + .1 && object[c].z > object[c].targetz - .1 && object[c].z < object[c].targetz + .1) object[c].active = FALSE;
				for (a = 0; a < nenemies[curmap]; a++)
				{			
					if (monsterinfo[curmap][a].health > 0)
					{
						targetx = monsterinfo[curmap][a].x;
						targety = monsterinfo[curmap][a].y;
						targetz = monsterinfo[curmap][a].z;
						if (object[c].x > targetx - clearance && object[c].x < targetx + clearance && object[c].y - 1.5 > targety - clearance && object[c].y - 1.5 < targety + clearance && object[c].z > targetz - clearance && object[c].z < targetz + clearance) 
						{
							object[c].active = FALSE;
							monsterinfo[curmap][a].health -= 2;
							monsterinfo[curmap][a].hue = 255;
							if (monsterinfo[curmap][a].health < 1)
							{
								health += monsterinfo[curmap][a].maxhealth / 2;
								numenemies++;
								if (numenemies == maxenemies) drawwin();
							}
						}
					}
				}
			}
		}
	}

}

void updphysics()
{
		
	focusofs[0] = focusofs[0] + (fightfocus[0] - focusofs[0]) * .09 * fpsr;
	focusofs[1] = focusofs[1] + (fightfocus[1] - focusofs[1]) * .09 * fpsr;
	focusofs[2] = focusofs[2] + (fightfocus[2] - focusofs[2]) * .09 * fpsr;
}

void updroom()
{
	
	room_clear[curmap] = TRUE;

	int c, whitec = makecol(255, 255, 255);

    float ofs, xx, yy, zz, cx, cz;
	
	float ox, oz, p, clearance = 1;

	bool passx = TRUE, passy = TRUE, pass = TRUE;
	

	ofs = .16 * fpsr;


	for (c = 0; c < nenemies[curmap]; c++)
	{
		if (monsterinfo[curmap][c].health > 0) 
		{
			room_clear[curmap] = FALSE;
			monsterinfo[curmap][c].curstatus = status_walking;
			monsterinfo[curmap][c].curframe += 2 * ofs;
			while (monsterinfo[curmap][c].curframe > 6) { monsterinfo[curmap][c].curframe -= 6; monsterinfo[curmap][c].curstatus = status_walking; }
		
			xx = monsterinfo[curmap][c].x;
			yy = monsterinfo[curmap][c].y;
			zz = monsterinfo[curmap][c].z;

			if (!(yy > playery - .5 && yy < playery + .5)) continue;
						
			ox = monsterinfo[curmap][c].headingx * monsterdata[monsterinfo[curmap][c].id].speed;
			oz = monsterinfo[curmap][c].headingz * monsterdata[monsterinfo[curmap][c].id].speed;

			cx = 64 + (xx - playerx) * 8;
			cz = 64 + (zz - playerz) * 8;

			if (oz < 0) monsterinfo[curmap][c].walkdir = up;
			if (oz > 0) monsterinfo[curmap][c].walkdir = down;
			if (ox < 0) monsterinfo[curmap][c].walkdir = left;
			if (ox > 0) monsterinfo[curmap][c].walkdir = right;


			p = getpixel(surroundbmp, cx + ox * ofs * 8, cz + oz * ofs * 8);
			if (p < whitec)
			{				
				p = float(p) / 256 - 2;
				if (p > -1.5 && p < 1.5)
				{
					yy += p;
					xx += ox * ofs;
					zz += oz * ofs;
			
				}
	
			} else {
				monsterinfo[curmap][c].headingx = short((float)rand() / RAND_MAX * 3) - 1;
				monsterinfo[curmap][c].headingz = short((float)rand() / RAND_MAX * 3) - 1;
				while (monsterinfo[curmap][c].headingz == monsterinfo[curmap][c].headingx) { monsterinfo[curmap][c].headingz = short((float)rand() / RAND_MAX * 3) - 1; }
			}
			
			
			monsterinfo[curmap][c].x = xx;
			monsterinfo[curmap][c].y = yy;
			monsterinfo[curmap][c].z = zz;

			if (monsterinfo[curmap][c].hue > 0) monsterinfo[curmap][c].hue /= 2;

			mdistance[c] = sqrt((playerx - xx) * (playerx - xx) + (playery - yy) * (playery - yy) + (playerz - zz) * (playerz - zz));
			if (mdistance[c] < 1)
			{
				monsterinfo[curmap][c].curstatus = status_attacking;
				if (monsterinfo[curmap][c].curframe < 2)
				{
					playerhue = 255;
					health -= monsterinfo[curmap][c].attack;
					if (health > 300) health = 300;
				}
			}

		}
	}
}