/*
  Generation Olympia Engine - C++ Port
  Project Home: http://www.sourceforge.net/projects/qb2c/
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  $Id: goengine.cpp,v 1.4 2004/01/20 02:48:43 syn9 Exp $
*/

#include "../engine/engineglobals.h"
#include "../engine/render.h"
#include "../engine/fileinput.h"

#include "gamefileinput.h"
#include "gameglobals.h"
#include "game.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(void)
{
    	
	current_fade_level = 0.0;
	target_fade_level = 1.0;

    fpsr = 1;

	printf("Initializing game data...\n");
	initialize(16, 0, 640, 480);

	gameinit();

	BITMAP *logo;

	logo = load_bmp("data/logo.bmp", pal);

	int x;

	for (x = 0; x < 256; x+=16)
	{
		set_trans_blender(0, 0, 0, x);
		clear_bitmap(offscreen);
		draw_trans_sprite(offscreen, logo, 0, 0);
		updscreen(TRUE);
	}

	set_trans_blender(0, 0, 0, 0);

	gtime = clock() + 2000;
	while (gtime < clock()) {}

	int lx, ly, w, h, whitec = makecol(192, 192, 192);

	char tmp[100];
	w = 320;
	h = 72;
	lx = xcenter - w / 2;
	ly = ycenter - h / 2;

	updscreen(TRUE);	

	win (0, lx, ly, lx + w, ly + h);
	sprintf(tmp, "You are Marik, The Demon Slayer");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 4, whitec);
	sprintf(tmp, "You have come from a far to the");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 16, whitec);
	sprintf(tmp, "lands of Vampira to rid the world");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 28, whitec);
	sprintf(tmp, "of the demon Hord.");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 40, whitec);
	

	sprintf(tmp, "Hit SPACE and let the killing begin!");
	textout(offscreen, font, tmp, xcenter - strlen(tmp) * 4, ly + 60, whitec);

	updscreen(TRUE);	

	while (!key[KEY_SPACE]) { poll_keyboard(); }


	updscreen(TRUE);

	calcsteps();
	load_triggers_v1();
	load_monsterdat();
	load_itemdat();
	
	load_file_v1("901");	
	setup_scene();
	setup_monsters();

	playerx = triggerinfo[curmap + 1000][1];
	playery = triggerinfo[curmap + 1000][2];
	playerz = triggerinfo[curmap + 1000][3];
	
	
	focusofs[0] = playerx;
	focusofs[1] = playery;
	focusofs[2] = playerz;

	fightfocus[0] = playerx;
	fightfocus[1] = playery;
	fightfocus[2] = playerz;

	int	cgrey = makecol(128,128,128);
	

	printf("Game data initialized, starting main loop...\n");	

	updphysics();

	vdist = viewdist;
	zm = 40;

	fpr = 60;

	
	
	do
    {		

        
		poll_keyboard();
		poll_mouse();

        start = vdist;
        depth = 0;
				
		calcpoints();
		calcsprites();
		
		sortpolys();

		checkkbd();
		updroom();
		process_trigger();		

		drawpolys();
		drawhud();
					    
		updphysics();
		updobjects();
		
		updscreen(TRUE);
		clear_to_color(offscreen, ambientc);

		cycle = cycle + ripplewash * fpsr;

		while (cycle > 16) { cycle = cycle - 16; }

		if (health < 1) drawdie();

	} while (!(key[KEY_ESC] || health < 1));

	deinit();

	return 0;
}
END_OF_MAIN();
